! This file is part of SusHi.
!
! It includes the call of FeynHiggs.
!

      subroutine runfeynhiggs(delmb)

      implicit none
      integer nmfv
      include 'commons/common-inputoutput.f'
      include 'commons/common-vars.f'
      include 'commons/common-quark.f'
      include 'commons/common-ren.f'
      include 'commons/common-consts.f'
      !FH specific variables
      double precision delmb,delAb
      double precision MASf(6,4),MCha(2),MNeu(4),MHtree(4)
      double precision MHiggs(4),SAtree,MSb(2),MbSL2
      double complex UASf(6,6,4),UCha(2,2),VCha(2,2),ZNeu(4,4)
      double complex SAeff,UHiggs(3,3),ZHiggs(3,3),USb(2,2)
      double complex DeltaMB,Deltab

      error = 0

      call FHSetFlags(error,
     &     mssmpart, fieldren, tanbren, higgsmix, p2approx,
     &     looplevel, runningMT, botResum, tlCplxApprox)
      
      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHSetFlags ', error
         write(*,105)
         stop
      endif
      
      call FHSetSMPara(error,
     &     invAlfa, AlfasMZ, GF,
     &     ME, MU, MD, MM, MC, MS, ML, mbmb,
     &     MW, MZ,
     &     CKMlambda, CKMA, CKMrhobar, CKMetabar)
      
      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHSetSMPara ', error
         write(*,105)
         stop
      endif
      
      call FHSetPara(error,scalefactor,MT,tanb,MA0,MHp,
     &     M3SL,M3SE,M3SQ,M3SU,M3SD,
     &     M2SL,M2SE,M2SQ,M2SU,M2SD,
     &     M1SL,M1SE,M1SQ,M1SU,M1SD,
     &     MUE,cAtau,cAt,cAb,
     &     cAmu,cAc,cAs,cAe,cAu,cAd,M_1,M_2,M_3,Qtau,Qt,Qb)
      
      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHSetPara ', error
         write(*,105)
         stop
      endif
      
      call FHGetPara(error, nmfv, MASf, UASf,
     &     MCha, UCha, VCha, MNeu, ZNeu, DeltaMB, MGl,
     &     MHtree, SAtree)
      
      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHGetPara ', error
         write(*,105)
         stop
      endif
      
      call FHHiggsCorr(error,MHiggs,SAeff,UHiggs,ZHiggs)
      
      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHHiggsCorr ', error
         write(*,105)
         stop
      endif
      
      call FHGetTLPara(error, MSb, USb, MbSL2, Deltab)
      
      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHGetTLPara ', error
         write(*,105)
         stop
      endif
      
      dMLb = MbSL2-M3SQ**2
      
!Set delmb equal to DeltaMB from FH - own calculation in renscheme.f
      delmb = Real(DeltaMB)
      
      Msbot1 = Msb(1)
      Msbot2 = Msb(2)
      
      cthetab = Real(Usb(1,1))
      sthetab = Real(Usb(1,2))
      
      alpha = dasin(Real(SAeff))
      Mstop1 = MASf(3,3)
      Mstop2 = MASf(6,3)
      cthetat = Real(UASf(3,3,3))
      sthetat = Real(UASf(3,6,3))
      muSUSY = Real(MUE)
      
!get thetat from cthetat and sthetat, 0<=thetat<Pi
      if (cthetat.gt.0.d0) then
         thetat = dasin(sthetat)
      else
         thetat = Pi-dasin(sthetat)
      endif
      
!thetab from OS-sbottom masses in renormalize()
      
      if (pseudo.eq.0) then
         Mh = MHiggs(1)         !h
      else if (pseudo.eq.1) then
         Mh = MHiggs(3)         !A
      else if (pseudo.eq.2) then
         Mh = MHiggs(2)         !H
      endif

 105  format('#--------------------------------------------------#')

      end
      
